package com.my;

import com.sun.grizzly.SSLConfig;
import java.net.URL;
import javax.net.ssl.SSLContext;

/**
 *
 * @author oleksiys
 */
public class SSLContextFactory {
    public static final String SSL_KEYSTORE = "/Users/oleksiys/Projects/GrizzlyAsyncSSL/resources/ssltest-keystore.jks";
    public static final String SSL_PASSWORD = "changeit";
    public static final String[] RECOMMENDED_PROTOCOLS = new String[]{"SSLv3"};

    public static org.apache.log4j.Logger logger = org.apache.log4j.Logger.getLogger(SSLContextFactory.class);

    private static SSLConfig sslConfig;
    
    static {
        sslConfig = new SSLConfig();
        ClassLoader cl = SSLContextFactory.class.getClassLoader();
        // override system properties
        URL cacertsUrl = cl.getResource("ssltest-cacerts.jks");
        if (cacertsUrl != null) {
            sslConfig.setTrustStoreFile(cacertsUrl.getFile());
        }
        
        logger.info("SSL certs path: " + sslConfig.getTrustStoreFile());
        
        // override system properties
        URL keystoreUrl = cl.getResource("ssltest-keystore.jks");
        if (keystoreUrl != null) {
            sslConfig.setKeyStoreFile(keystoreUrl.getFile());
        }
        
//        sslConfig.setSecurityProtocol(RECOMMENDED_PROTOCOLS[0]);
        
        logger.info("SSL keystore path: " + sslConfig.getKeyStoreFile());
        SSLConfig.DEFAULT_CONFIG = sslConfig;
    }
    
    public static SSLContext createSSLContext() throws Exception {
        return sslConfig.createSSLContext();
    }
}
