package com.my.server.grizzly;

import com.my.server.Server;
import com.my.server.ServerConnectionHandler;
import com.sun.grizzly.Context;
import com.sun.grizzly.ProtocolFilter;
import com.sun.grizzly.SSLSelectorHandler;
import com.sun.grizzly.util.AttributeHolder;
import com.sun.grizzly.util.WorkerThread;
import org.apache.log4j.Logger;

import javax.net.ssl.SSLEngine;
import javax.net.ssl.SSLSession;
import java.io.IOException;
import java.nio.ByteBuffer;
import java.nio.channels.SelectionKey;
import java.nio.channels.SocketChannel;

/**
 * Date: Jul 11, 2008
 * Time: 2:01:52 PM
 */
public class MySSLProcessor implements ProtocolFilter {
    public static Logger logger = Logger.getLogger(MySSLProcessor.class);
    private boolean useAsyncReads = false;
    private Server server;

    private final Object lockObject = new Object();

	// Async reads is ruled out.
    public MySSLProcessor(Server server, boolean isAsyncReads) {
        super();
        this.server = server;
        this.useAsyncReads = false;
        if (logger.isDebugEnabled()) {
            logger.debug("useAsyncReads - " + isAsyncReads);
        }
    }

    // Not Using Async reads as of now.
    public boolean execute(Context context) throws IOException {
        WorkerThread workerThread = (WorkerThread) Thread.currentThread();
        
        SelectionKey selectionKey = context.getSelectionKey();
        SSLEngine engine = workerThread.getSSLEngine();
        ServerConnectionHandler conHandler;

//        synchronized (lockObject) {
            AttributeHolder holder = (AttributeHolder) selectionKey.attachment();
            Object obj = holder.getAttribute(ServerConnectionHandler.class.getName());
            if (obj == null || !(obj instanceof ServerConnectionHandler)) {
                SSLSelectorHandler selectorHandler = (SSLSelectorHandler) context.getSelectorHandler();
                conHandler = new ServerConnectionHandler(selectorHandler, selectionKey, (SocketChannel) selectionKey.channel(), engine);
                server.addConHandler(conHandler);
                holder.setAttribute(ServerConnectionHandler.class.getName(), conHandler);
            } else {
                conHandler = (ServerConnectionHandler) obj;
            }

            ByteBuffer bb = workerThread.getByteBuffer();
            bb.flip();
            
            conHandler.read(bb);
            
            byte[] data = new byte[bb.remaining()];
            bb.get(data);
            bb.clear();
            System.out.println("Channel: " + context.getSelectionKey().channel() + " Info: " + new String(data));
            conHandler.sendBytes(data, "");
//        }
        return true;
    }

    public boolean postExecute(Context arg0) throws IOException {
        return true;
    }
}